﻿// Author: Alexander Sorokin
// Copyright: University of Illinois at Urbana-Champaign
// License terms: BSD license, attribution required

package vision{

	import flash.display.*;
	import fl.controls.CheckBox;
	import fl.controls.List;
	import fl.data.DataProvider;
	//import flash.display.Shape;
	import fl.controls.Label;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.xml.XMLDocument;
	import flash.xml.XMLNode;
	import flash.text.*;
	
	import vision.BBoxInputToken;
	import vision.PolygonalDisplay;
	import vision.MarkSymbol2;
	//import vision.CheckBox2;

	dynamic public class InputSpecsControl extends MovieClip
	{
		var presence_targets:Array;
		var bbox_targets:Array;
		var polygon_targets:Array;
		
		var rootObj;
		
		function InputSpecsControl() {
			//m_TmpPresense.m_Check.label="asdas";
			//m_lbl.label="12qweqweqweq";
			presence_targets=new Array();
			bbox_targets=new Array();
			polygon_targets=new Array();
		}
		
		public function read_task(task_definition:XML,newRootObj,bViewOnly:Boolean=false):void{
			//var c:XMLNode;
			this.rootObj=newRootObj;
			
			var targets:XMLList=task_definition.targets.target;
			for each(var c in targets){
				if(c.annotation.@type=="presence"){
					presence_targets.push(new Array(c));
				}else if(c.annotation.@type=="bbox"){
					bbox_targets.push(c);
				}else if(c.annotation.@type=="outline"){
					polygon_targets.push(c);
				}else{
					trace('Unknown');
				}
				trace(c.@name);	
				trace(c.annotation.@type);	
			}
			setup_lists(bViewOnly);
		}

		public function read_task_w_annotation(task_definition:XML,annotations:XML,newRootObj):void{
			//var c:XMLNode;
			read_task(task_definition,newRootObj,true);
			//return;
			//var offsetY:Number=0;
			var binary_decisions:Array=new Array();
			var absent_tgts:XMLList=annotations.annotation.absent;
			var present_tgts:XMLList=annotations.annotation.present;
			var o;
			for each( o in absent_tgts){
				binary_decisions[o.@name]=0;				
			}
			
			for each( o in present_tgts){
				binary_decisions[o.@name]=1;				
			}
			for each(var oA in presence_targets){
					var ctl:CheckBox=oA[1];
					var o = oA[0];
					ctl.selected=binary_decisions[o.@name];
					oA[2]=o.@ct;
					//ctl.x=0;
					//ctl.y=offsetY;
					//this.addChild(ctl);
					//offsetY+=ctl.height;
			}
			var bboxes:XMLList=annotations.annotation.bbox;
			for each( o in bboxes){
				//var bboxInput:BBoxInput=new BBoxInput();
				//bboxInput.setXML(o);
				//<bbox name="lamp" sqn="1" left="334.89000000000004" top="27.067500000000003" width="23.625" height="20.11500000000001"/>		
	
				var lx,ly,lw,lh,bX,bY,bW,bH;
				lx=o.@left;
				ly=o.@top;
				lw=o.@width;
				lh=o.@height;
				bX=lx/rootObj.ratio+rootObj.oX;
				bY=ly/rootObj.ratio+rootObj.oY;
				bW=lw/rootObj.ratio;
				bH=lh/rootObj.ratio;
			
				//box_points.push(new Rectangle(lx,ly, lw,lh));
		
				var thePolygon= new Shape();    
				var lineColor=0x0000FF;
				thePolygon.graphics.lineStyle(2, lineColor, 1, false, LineScaleMode.VERTICAL,
												CapsStyle.NONE, JointStyle.MITER, 10);	
				thePolygon.graphics.moveTo(bX,bY);
				thePolygon.graphics.lineTo(bX+bW,bY);
				thePolygon.graphics.lineTo(bX+bW,bY+bH);
				thePolygon.graphics.lineTo(bX,bY+bH);
				thePolygon.graphics.lineTo(bX,bY);
				rootObj.the_sites_holder.addChild(thePolygon);
				
				var tag:TextField=new TextField();
				
				tag.text=o.@sqn+" "+o.@name;
				
				tag.background=false;
				tag.autoSize=TextFieldAutoSize.RIGHT;				
				rootObj.the_sites_holder.addChild(tag);
				tag.x=bX+bW/2-tag.width/2;
				tag.y=bY+bH/2-tag.height/2;					
	
				tag=new TextField();
				
				tag.text=o.@sqn+" "+o.@name;
				
				tag.background=false;
				tag.autoSize=TextFieldAutoSize.RIGHT;				
				rootObj.the_sites_holder.addChild(tag);
				tag.x=bX+bW/2-tag.width/2+2;
				tag.y=bY+bH/2-tag.height/2+2;
				tag.textColor=0xFFFFFF;
					
			}
			
			var polygons:XMLList=annotations.annotation.polygon;
			for each( o in polygons){
				var polyDisplay:vision.PolygonalDisplay=new vision.PolygonalDisplay();
				polyDisplay.read_xml_annotation(o);
				polyDisplay.Mode = polyDisplay.IDLE;
				polyDisplay.btnRemoveLast.visible=false;
				polyDisplay.m_cover.visible=false;
				rootObj.the_sites_holder.addChild(polyDisplay);
				var tag:TextField=new TextField();
				
				tag.text=o.@sqn+" "+o.@name;
				
				tag.background=false;
				tag.autoSize=TextFieldAutoSize.RIGHT;				
				rootObj.the_sites_holder.addChild(tag);
				tag.x=polyDisplay.ptsX[1];
				tag.y=polyDisplay.ptsY[1];					
	
				tag=new TextField();
				
				tag.text=o.@sqn+" "+o.@name;
				
				tag.background=false;
				tag.autoSize=TextFieldAutoSize.RIGHT;				
				rootObj.the_sites_holder.addChild(tag);
				tag.x=polyDisplay.ptsX[1]+2;
				tag.y=polyDisplay.ptsY[1]+2;					
				tag.textColor=0xFFFFFF;
				
				var m:vision.MarkSymbol2 = new vision.MarkSymbol2;
				rootObj.the_sites_holder.addChild(m);
				m.x=polyDisplay.ptsX[1];
				m.y=polyDisplay.ptsY[1];					
			
			}
				
		}

		function record_checkbox_time(event:Event):void {
			var now:Date=new Date();	
			var click_time=now.getTime();
			for each(var oA in presence_targets){
				if(oA[1]==event.target){
					oA[2]=click_time;
					break;
				}
			}
		}
		function setup_lists(bViewOnly:Boolean=false):void
		{ 
			var offsetY=0;
			
			if(presence_targets.length>0){
				var l:Label=new Label();
				l.text="Objects present";
				l.x=0;
				l.y=offsetY;
				this.addChild(l);
				offsetY+=l.height;
				for each(var oA in presence_targets){
					//var ctl =new CheckBox2();
					var ctl:CheckBox=new CheckBox();
					ctl.width=160;
					//ctl.name=o.@name;
					var o = oA[0];
					
					ctl.label=o.@name;
					oA.push(ctl);
					ctl.x=0;
					ctl.y=offsetY;
					oA.push(-1);
					ctl.addEventListener(Event.CHANGE, this.record_checkbox_time);
					this.addChild(ctl);
					offsetY+=ctl.height;
				}
			}
			var HBox=27;
			if(bbox_targets.length>0){
				var l:Label=new Label();
				l.text="Object boxes";
				l.x=0;
				l.y=offsetY;
				this.addChild(l);
				offsetY+=l.height;
				for each(var o in bbox_targets){
					var ctlBox:BBoxInputToken=new BBoxInputToken();
					if(bViewOnly){
						ctlBox.m_input_btn.enabled=false;
					}
					//ctl.name=o.@name;
					ctlBox.set_name(o.@name);
					ctlBox.set_root(this.rootObj);
					o.ctl=ctlBox;
					ctlBox.x=0;
					ctlBox.y=offsetY;
					this.addChild(ctlBox);
					//offsetY+=ctlBox.height;
					offsetY+=HBox;
				}
			}
			var HBox=27;
			if(polygon_targets.length>0){
				var l:Label=new Label();
				l.text="Outlines";
				l.x=0;
				l.y=offsetY;
				this.addChild(l);
				offsetY+=l.height;
				for each(var o in polygon_targets){
					var ctlBoxPoly:PolygonInputToken=new PolygonInputToken();
					if(bViewOnly){
						ctlBoxPoly.m_input_btn.enabled=false;
					}
					
					//ctl.name=o.@name;
					ctlBoxPoly.set_name(o.@name);
					ctlBoxPoly.set_root(this.rootObj);
					o.ctl=ctlBoxPoly;
					ctlBoxPoly.x=0;
					ctlBoxPoly.y=offsetY;
					this.addChild(ctlBoxPoly);
					//offsetY+=ctlBox.height;
					offsetY+=HBox;
				}
			}
		}
		public function collect_results():String
		{
			var xmlStr:String="";
			for each(var oA:Object in this.presence_targets){
				//var chkBox = oA[1];
				var chkBox:CheckBox=oA[1];
				var ct = oA[2];
				if (chkBox.selected){
					xmlStr+='<present name="'+chkBox.label+'" explicit="1" ct="'+ct+'"/>\n';
				}else{
					xmlStr+='<absent name="'+chkBox.label+'" explicit="0" ct="'+ct+'"/>\n';			
				}
			}
			var inpData:DataProvider=this.rootObj.shapesListBox.dataProvider;
			var dataElements:Array=inpData.toArray();
			for each(var oS:Object in dataElements){
				trace(oS);
				if (oS is BBoxInput)
				{
					var bboxInput:BBoxInput=BBoxInput(oS);
					xmlStr+=bboxInput.get_xml_annotation() ;		
				}else if(oS is PolygonalDisplay)
				{
					var outlineInput:PolygonalDisplay=PolygonalDisplay(oS);
					xmlStr+=outlineInput.get_xml_annotation() ;		
				}
			}
			return "<annotation>\n"+xmlStr+"</annotation>\n";
		}
	}
}